function facebook_getLoginStatus(wishlist, lang) {
    FB.getLoginStatus(function(response) {
                      if (response.status == 'connected') {
                      //alert('logged in');
                      if (wishlist) {
                      if (lang == 'en') {
                      facebookWallPost();
                      }else {
                      facebookJpWallPost();
                      }
                      }else {
                      if (lang == 'en') {
                      facebookGenericWallPost();
                      }else {
                      facebookJpGenericWallPost();
                      }
                      }
                      } else {
                      //alert('not logged in');
                      facebook_login(wishlist);
                      }
                      });
}

function facebook_logout() {
    FB.logout(function(response) {
              //alert('logged out');
              });
}

function facebook_login(wishlist) {
    FB.login(
             function(response) {
             if (response.status == 'connected') {
             //alert('logged in');
             if (wishlist) {
             facebookWallPost();
             }else {
             facebookGenericWallPost();
             }
             } else {
             alert('login was not successful');
             }
             },
             { scope: "email" });
}


function facebookWallPost() {
    //console.log('Debug 1');
    var encoded_str = encoded_wishlist_str();
    
    var params = {
    method: 'feed',
    name: 'My Wishlist - Created Using the Trick Bag Snowboarding App',
    link: 'http://www.trickbagapp.com/my_wishlist/?' + encoded_str,
    picture: 'http://www.trickbagapp.com/icon-72-2.png',
    caption: 'SNOWBOARDING',
    description: 'Check my trick wishlist'
    };
    console.log(params);
    FB.ui(params, function(obj) { console.log(obj);});
}

function facebookGenericWallPost() {
    //console.log('Debug 1');
    var encoded_str = encoded_wishlist_str();
    
    var params = {
    method: 'feed',
    name: 'The Trick Bag Snowboarding App',
    link: 'http://www.trickbagapp.com/itunes/',
    picture: 'http://www.trickbagapp.com/icon-72-2.png',
    caption: 'SNOWBOARDING',
    description: 'Learning new tricks!'
    };
    console.log(params);
    FB.ui(params, function(obj) { console.log(obj);});
}


function facebookJpWallPost() {
    //console.log('Debug 1');
    var encoded_str = encoded_wishlist_str();
    
    var params = {
    method: 'feed',
    name: 'マイ ウィッシュリストは<br/>トリックバッグのアップリで<br/>作りました。',
    link: 'http://www.trickbagapp.com/my_wishlist/?' + encoded_str,
    picture: 'http://www.trickbagapp.com/icon-72-2.png',
    caption: 'SNOWBOARDING',
    description: 'マイ　トリック　ウィッシュリストをチェックする'
    };
    console.log(params);
    FB.ui(params, function(obj) { console.log(obj);});
}

function facebookJpGenericWallPost() {
    //console.log('Debug 1');
    var encoded_str = encoded_wishlist_str();
    
    var params = {
    method: 'feed',
    name: 'トリック バッグのスノーボード<br/>アップリ',
    link: 'http://www.trickbagapp.com/itunes/',
    picture: 'http://www.trickbagapp.com/icon-72-2.png',
    caption: 'SNOWBOARDING',
    description: '新しいトリックを覚えています！'
    };
    console.log(params);
    FB.ui(params, function(obj) { console.log(obj);});
}


function encoded_wishlist_str() {
    var wishlist_str = '';
    
    wishlist_str += 'rr=';
    $('#rails-reg-wrapper li:not(.try_switch)').each(function() {
                                                     var plusbox = $(this).find('input.plusBox');
                                                     var checkbox = $(this).find('input.checkBox:not(.plusBox)');
                                                     
                                                     if (!plusbox.is(':checked')) {
                                                     wishlist_str += '0';
                                                     }else if (!checkbox.is(':checked')) {
                                                     wishlist_str += '1';
                                                     }else {
                                                     wishlist_str += '2';
                                                     }
                                                     });
    
    wishlist_str += '&gr=';
    $('#rails-goofy-wrapper li:not(.try_switch)').each(function() {
                                                       var plusbox = $(this).find('input.plusBox');
                                                       var checkbox = $(this).find('input.checkBox:not(.plusBox)');
                                                       
                                                       if (!plusbox.is(':checked')) {
                                                       wishlist_str += '0';
                                                       }else if (!checkbox.is(':checked')) {
                                                       wishlist_str += '1';
                                                       }else {
                                                       wishlist_str += '2';
                                                       }
                                                       });
    
    wishlist_str += '&rj=';
    $('#jumps-reg-wrapper li:not(.try_switch)').each(function() {
                                                     var plusbox = $(this).find('input.plusBox');
                                                     var checkbox = $(this).find('input.checkBox:not(.plusBox)');
                                                     
                                                     if (!plusbox.is(':checked')) {
                                                     wishlist_str += '0';
                                                     }else if (!checkbox.is(':checked')) {
                                                     wishlist_str += '1';
                                                     }else {
                                                     wishlist_str += '2';
                                                     }
                                                     });
    
    wishlist_str += '&gj=';
    $('#jumps-goofy-wrapper li:not(.try_switch)').each(function() {
                                                       var plusbox = $(this).find('input.plusBox');
                                                       var checkbox = $(this).find('input.checkBox:not(.plusBox)');
                                                       
                                                       if (!plusbox.is(':checked')) {
                                                       wishlist_str += '0';
                                                       }else if (!checkbox.is(':checked')) {
                                                       wishlist_str += '1';
                                                       }else {
                                                       wishlist_str += '2';
                                                       }
                                                       });
    
    return wishlist_str;
}

// LZW-compress a string
function lzw_encode(s) {
    var dict = {};
    var data = (s + "").split("");
    var out = [];
    var currChar;
    var phrase = data[0];
    var code = 256;
    for (var i=1; i<data.length; i++) {
        currChar=data[i];
        if (dict[phrase + currChar] != null) {
            phrase += currChar;
        }
        else {
            out.push(phrase.length > 1 ? dict[phrase] : phrase.charCodeAt(0));
            dict[phrase + currChar] = code;
            code++;
            phrase=currChar;
        }
    }
    out.push(phrase.length > 1 ? dict[phrase] : phrase.charCodeAt(0));
    for (var i=0; i<out.length; i++) {
        out[i] = String.fromCharCode(out[i]);
    }
    return out.join("");
}

function facebookAlertDismissed() {}


document.addEventListener('deviceready', function() {
                          try {
                          FB.init({ appId: "490437064311249", nativeInterface: CDV.FB, useCachedDialogs: false });
                          } catch (e) {
                          navigator.notification.alert('An error occurred while initializing the Facebook connection.', facebookAlertDismissed, 'Trick Bag');
                          }
                          }, false);




function instagram_share() {
    var time = (new Date()).getTime();
    setTimeout(function () {
        var now = (new Date()).getTime();
        if ((now - time) < 300) {
            window.open('http://www.instagram.com/trickbagapp', '_system');
        }
    }, 25);

    window.open('instagram://camera', '_system');
}

function vine_share() {
    var time = (new Date()).getTime();
    setTimeout(function() {
        var now = (new Date()).getTime();
        if((now-time)<300) {
            window.open('http://itunes.com/apps/vine', '_system');
        }
    }, 25);

    window.open('vine://app', '_system');
}

function instagram_hashtag() {
    var time = (new Date()).getTime();
    setTimeout(function() {
        var now = (new Date()).getTime();
        if((now-time)<300) {
            window.open('http://www.instagram.com/trickbagsnowapp', '_system');
        }
    }, 25);

    window.open('instagram://tag?name=trickbagsnowapp', '_system');
}

function instagram_page() {
    var time = (new Date()).getTime();
    setTimeout(function() {
        var now = (new Date()).getTime();
        if((now-time)<300) {
            window.open('http://www.instagram.com/trickbagsnowapp', '_system');
        }
    }, 25);

    window.open('instagram://user?username=trickbagsnowapp', '_system');
}
