/*
 The file downloading is accomplished using the Cordova API for phonegap. The process consists of a series of ASYNC calls.
 */

var first_run = false;
var init_lang = '';
var download_lang = 'eng';
var tl_dir_entry;
var flag_set, flag_entry;
var download_queue = new Array();
var selection_queue = new Array();
var exists_queue = new Array();
var num_files_to_download = 0;

var exists_str = '';
var no_exist_str = '';


var tl_video_map = {
    rails : {
        regular : {
            'level1' : {
                '1_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/1.FS_5050-640x360.m4v',
                '2_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/2.FS_Boardslide-640x360.m4v',
                '3_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/3.FS_Nosepress-640x360.m4v',
                '4_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/4.FS_Tailpress-640x360.m4v',
                '5_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/5.FS_Lipslide-640x360.m4v',
                '6_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/6.BS_5050-640x360.m4v',
                '7_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/7.BS_Boardslide-640x360.m4v',
                '8_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/8.BS_Nosepress-640x360.m4v',
                '9_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/9.BS_Tailpress-640x360.m4v',
                '10_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/10.BS_Lipslide-640x360.m4v'
            },
            'level2' : {
                '11_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/11.FS_5050_FS_180-640x360.m4v',
                '12_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/12.FS_Boardslide_BS_270-640x360.m4v',
                '13_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/13.FS_Nosepress_FS_180-640x360.m4v',
                '14_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/14.FS_Tailpress_FS_180-640x360.m4v',
                '15_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/15.FS_Lipslide_FS_270-640x360.m4v',
                '16_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/16.BS_5050_BS_180-640x360.m4v',
                '17_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/17.BS_Boardslide_FS_270-640x360.m4v',
                '18_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/18.BS_Nosepress_BS_180-640x360.m4v',
                '19_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/19.BS_Tailpress_BS_180-640x360.m4v',
                '20_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/20.BS_Lipslide_BS_270-640x360.m4v'
            },
            'level3' : {
                '21_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/21.FS_5050_BS_180-640x360.m4v',
                '22_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/22.FS_Boardslide_FS_270-640x360.m4v',
                '23_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/23.FS_Nosepress_BS_180-640x360.m4v',
                '24_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/24.FS_Tailpress_BS_180-640x360.m4v',
                '25_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/25.FS_Lipslide_BS_270-640x360.m4v',
                '26_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/26.BS_5050_FS_180-640x360.m4v',
                '27_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/27.BS_Boardslide_BS_270-640x360.m4v',
                '28_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/28.BS_Nosepress_FS_180-640x360.m4v',
                '29_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/29.BS_Tailpress_FS_180-640x360.m4v',
                '30_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/30.BS_Lipslide_FS_270-640x360.m4v'
            },
            'level4' : {
                '31_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/31.FS_180_5050-640x360.m4v',
                '32_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/32.FS_270_Lipslide-640x360.m4v',
                '33_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/33.FS_180_Nosepress-640x360.m4v',
                '34_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/34.FS_180_Tailpress-640x360.m4v',
                '35_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/35.FS_270_Lipslide_HW-640x360.m4v',
                '36_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/36.BS_180_5050-640x360.m4v',
                '37_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/37.BS_270_Lipslide-640x360.m4v',
                '38_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/38.BS_180_Nosepress-640x360.m4v',
                '39_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/39.BS_180_Tailpress-640x360.m4v',
                '40_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/40.BS_270_Lipslide_HW-640x360.m4v'
            },
            'level5' : {
                '41_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/41.FS_180_5050_BS_180-640x360.m4v',
                '42_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/42.FS_270_Lipslide_270-640x360.m4v',
                '43_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/43.FS_180_Nosepress_BS_180-640x360.m4v',
                '44_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/44.FS_180_Tailpress_BS_180-640x360.m4v',
                '45_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/45.FS_270_Lipslide_270_HW-640x360.m4v',
                '46_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/46.BS_180_5050_FS_180-640x360.m4v',
                '47_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/47.BS_270_Lipslide_270-640x360.m4v',
                '48_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/48.BS_180_Nosepress_FS_180-640x360.m4v',
                '49_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/49.BS_180_Tailpress_FS_180-640x360.m4v',
                '50_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/50.BS_270_Lipslide_270_HW-640x360.m4v'
            },
            'level6' : {
                '51_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/51.FS_180_5050_FS_180-640x360.m4v',
                '52_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/52.FS_270_Lipslide_Fakie-640x360.m4v',
                '56_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/regular/53.BS_180_5050_BS_180-640x360.m4v'
            }
        },
        goofy : {
            'level1' : {
                '1_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/1.G_FS_5050-640x360.m4v',
                '2_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/2.G_FS_Boardslide-640x360.m4v',
                '3_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/3.G_FS_Nosepress-640x360.m4v',
                '4_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/4.G_FS_Tailpress-640x360.m4v',
                '5_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/5.G_FS_Lipslide-640x360.m4v',
                '6_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/6.G_BS_5050-640x360.m4v',
                '7_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/7.G_BS_Boardslide-640x360.m4v',
                '8_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/8.G_BS_Nosepress-640x360.m4v',
                '9_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/9.G_BS_Tailpress-640x360.m4v',
                '10_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/10.G_BS_Lipslide-640x360.m4v'
            },
            'level2' : {
                '11_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/11.G_FS_5050_FS_180-640x360.m4v',
                '12_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/12.G_FS_Boardslide_BS_270-640x360.m4v',
                '13_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/13.G_FS_Nosepress_FS_180-640x360.m4v',
                '14_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/14.G_FS_Tailpress_FS_180-640x360.m4v',
                '15_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/15.G_FS_Lipslide_FS_270-640x360.m4v',
                '16_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/16.G_BS_5050_BS_180-640x360.m4v',
                '17_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/17.G_BS_Boardslide_FS_270-640x360.m4v',
                '18_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/18.G_BS_Nosepress_BS_180-640x360.m4v',
                '19_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/19.G_BS_Tailpress_BS_180-640x360.m4v',
                '20_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/20.G_BS_Lipslide_BS_270-640x360.m4v'
            },
            'level3' : {
                '21_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/21.G_FS_5050_BS_180-640x360.m4v',
                '22_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/22.G_FS_Boardslide_FS_270-640x360.m4v',
                '23_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/23.G_FS_Nosepress_BS_180-640x360.m4v',
                '24_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/24.G_FS_Tailpress_BS_180-640x360.m4v',
                '25_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/25.G_FS_Lipslide_BS_270-640x360.m4v',
                '26_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/26.G_BS_5050_FS_180-640x360.m4v',
                '27_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/27.G_BS_Boardslide_BS_270-640x360.m4v',
                '28_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/28.G_BS_Nosepress_FS_180-640x360.m4v',
                '29_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/29.G_BS_Tailpress_FS_180-640x360.m4v',
                '30_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/30.G_BS_Lipslide_FS_270-640x360.m4v'
            },
            'level4' : {
                '31_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/31.G_FS_180_5050-640x360.m4v',
                '32_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/32.G_FS_270_Lipslide-640x360.m4v',
                '33_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/33.G_FS_180_Nosepress-640x360.m4v',
                '34_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/34.G_FS_180_Tailpress-640x360.m4v',
                '35_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/35.G_FS_270_Lipslide_HW-640x360.m4v',
                '36_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/36.G_BS_180_5050-640x360.m4v',
                '37_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/37.G_BS_270_Lipslide-640x360.m4v',
                '38_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/38.G_BS_180_Nosepress-640x360.m4v',
                '39_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/39.G_BS_180_Tailpress-640x360.m4v',
                '40_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/40.G_BS_270_Lipslide_HW-640x360.m4v'
            },
            'level5' : {
                '41_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/41.G_FS_180_5050_BS_180-640x360.m4v',
                '42_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/42.G_FS_270_Lipslide_270-640x360.m4v',
                '43_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/43.G_FS_180_Nosepress_BS_180-640x360.m4v',
                '44_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/44.G_FS_180_Tailpress_BS_180-640x360.m4v',
                '45_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/45.G_FS_270_Lipslide_270_HW-640x360.m4v',
                '46_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/46.G_BS_180_5050_FS_180-640x360.m4v',
                '47_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/47.G_BS_270_Lipslide_270-640x360.m4v',
                '48_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/48.G_BS_180_Nosepress_FS_180-640x360.m4v',
                '49_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/49.G_BS_180_Tailpress_FS_180-640x360.m4v',
                '50_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/50.G_BS_270_Lipslide_270_HW-640x360.m4v'
            },
            'level6' : {
                '51_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/51.G_FS_180_5050_FS_180-640x360.m4v',
                '52_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/52.G_FS_270_Lipslide_Fakie-640x360.m4v',
                '56_FQ-iPhone.m4v' : 'http://www.trickbagapp.com/videos/rails/goofy/53.G_BS_180_5050_BS_180-640x360.m4v'
            }
        }
    },

    jumps : {
        regular : {
            'level1' : {
                '1_INDY_GRAB_480.m4v' : 'http://www.trickbagapp.com/Jumping/Regular/1_INDY_GRAB_480.m4v',
                '2_MUTE_GRAB_480.m4v' : 'http://www.trickbagapp.com/Jumping/Regular/2_MUTE_GRAB_480.m4v',
                '3_MELAN_GRAB_480.m4v' : 'http://www.trickbagapp.com/Jumping/Regular/3_MELAN_GRAB_480.m4v',
                '4_STALEFISH_GRAB_480.m4v' : 'http://www.trickbagapp.com/Jumping/Regular/4_STALEFISH_GRAB_480.m4v',
                '5_TAIL_GRAB_480.m4v' : 'http://www.trickbagapp.com/Jumping/Regular/5_TAIL_GRAB_480.m4v',
                '6_NOSE_GRAB_480.m4v' : 'http://www.trickbagapp.com/Jumping/Regular/6_NOSE_GRAB_480.m4v'
            },
            'level2' : {
                '7.3_FRONTSIDE180_480.m4v' : 'http://www.trickbagapp.com/Jumping/Regular/7.3_FRONTSIDE180_480.m4v'
            },
            'level3' : {
                '8.2_BACKSIDE180_MUTE_KM_480.m4v' : 'http://www.trickbagapp.com/Jumping/Regular/8.2_BACKSIDE180_MUTE_KM_480.m4v',
                '8.3_BACKSIDE180_MELAN_480.m4v' : 'http://www.trickbagapp.com/Jumping/Regular/8.3_BACKSIDE180_MELAN_480.m4v'
            },
            'level4' : {
                '9.1_FRONTSIDE360_480.m4v' : 'http://www.trickbagapp.com/Jumping/Regular/9.1_FRONTSIDE360_480.m4v',
                '9.2.Frontside360_Mute_640.mp4' : 'http://www.trickbagapp.com/videos/jumps/regular/9.2.Frontside360_Mute_640.mp4',
                '9.3.Frontside360_Melon.mp4' : 'http://www.trickbagapp.com/videos/jumps/regular/9.3.Frontside360_Melon.mp4',
                '9.4_FRONTSIDE360_STALEFISH_MASARU_480.m4v' : 'http://www.trickbagapp.com/Jumping/Regular/9.4_FRONTSIDE360_STALEFISH_MASARU_480.m4v'

            },
            'level5' : {
                '10.1_BACKSIDE360_INDY_KM_480.m4v' : 'http://www.trickbagapp.com/Jumping/Regular/10.1_BACKSIDE360_INDY_KM_480.m4v',
                '10.5_BACKSIDE360_TAIL_480.m4v' : 'http://www.trickbagapp.com/Jumping/Regular/10.5_BACKSIDE360_TAIL_480.m4v'
            },
            'level6' : {
                '11.2_FRONTSIDE540_MUTE_MK_480.m4v' : 'http://www.trickbagapp.com/Jumping/Regular/11.2_FRONTSIDE540_MUTE_MK_480.m4v',
                '11.3_FRONTSIDE540_480.m4v' : 'http://www.trickbagapp.com/Jumping/Regular/11.3_FRONTSIDE540_480.m4v'
            },
            'level7' : {
                '12.1_BACKSIDE540_INDY_480.m4v' : 'http://www.trickbagapp.com/Jumping/Regular/12.1_BACKSIDE540_INDY_480.m4v'
            },
            'level8' : {
                '13.3_FRONTSIDE720_MELAN_480.m4v' : 'http://www.trickbagapp.com/Jumping/Regular/13.3_FRONTSIDE720_MELAN_480.m4v'
            },
            'level9' : {
                '14.1_BACKSIDE_720_INDY_480.m4v' : 'http://www.trickbagapp.com/Jumping/Regular/14.1_BACKSIDE_720_INDY_480.m4v',
                '14.2_BACKSIDE720_MUTE_KM_480.m4v' : 'http://www.trickbagapp.com/Jumping/Regular/14.2_BACKSIDE720_MUTE_KM_480.m4v'
            },
            'level10' : {
                'BONUS1_METHOD_480.m4v' : 'http://www.trickbagapp.com/Jumping/Regular/BONUS1_METHOD_480.m4v',
                'BONUS2_BACKFLIP_480.m4v' : 'http://www.trickbagapp.com/Jumping/Regular/BONUS2_BACKFLIP_480.m4v',
                'BONUS3_UNDERFLIP_KM_480.m4v' : 'http://www.trickbagapp.com/Jumping/Regular/BONUS3_UNDERFLIP_KM_480.m4v',
                'BONUS4_15.5_FRONTSIDE900_TAIL_480.m4v' : 'http://www.trickbagapp.com/Jumping/Regular/BONUS4_15.5_FRONTSIDE900_TAIL_480.m4v',
                'BONUS5_16.2_BACKSIDE900_MUTE_480.m4v' : 'http://www.trickbagapp.com/Jumping/Regular/BONUS5_16.2_BACKSIDE900_MUTE_480.m4v',
                'BONUS6_ONEFOOT_INDY_480.m4v' : 'http://www.trickbagapp.com/Jumping/Regular/BONUS6_ONEFOOT_INDY_480.m4v',
                'BONUS7_ONEFOOT_BACKSIDE180_480.m4v' : 'http://www.trickbagapp.com/Jumping/Regular/BONUS7_ONEFOOT_BACKSIDE180_480.m4v',
                'BONUS8_ONEFOOT_FRONTSIDE360_480.m4v' : 'http://www.trickbagapp.com/Jumping/Regular/BONUS8_ONEFOOT_FRONTSIDE360_480.m4v',
                'BONUS9_ONEFOOT_FRONTSIDE540_480.m4v' : 'http://www.trickbagapp.com/Jumping/Regular/BONUS9_ONEFOOT_FRONTSIDE540_480.m4v',
                'BONUS10_ONEFOOT_BACKFLIP_480.m4v' : 'http://www.trickbagapp.com/Jumping/Regular/BONUS10_ONEFOOT_BACKFLIP_480.m4v'
            }
        },
        goofy : {
            'level1' : {
                '1_INDY_GRAB_G_480.m4v' : 'http://www.trickbagapp.com/Jumping/Goofy/1_INDY_GRAB_G_480.m4v',
                '2_MUTE_GRAB_G_480.m4v' : 'http://www.trickbagapp.com/Jumping/Goofy/2_MUTE_GRAB_G_480.m4v',
                '3_MELAN_GRAB_G_480.m4v' : 'http://www.trickbagapp.com/Jumping/Goofy/3_MELAN_GRAB_G_480.m4v',
                '4_STALEFISH_GRAB_G_480.m4v' : 'http://www.trickbagapp.com/Jumping/Goofy/4_STALEFISH_GRAB_G_480.m4v',
                '5_TAIL_GRAB_G_480.m4v' : 'http://www.trickbagapp.com/Jumping/Goofy/5_TAIL_GRAB_G_480.m4v',
                '6_NOSE_GRAB_G_480.m4v' : 'http://www.trickbagapp.com/Jumping/Goofy/6_NOSE_GRAB_G_480.m4v'
            },
            'level2' : {
                '7.3_FRONTSIDE180_G_480.m4v' : 'http://www.trickbagapp.com/Jumping/Goofy/7.3_FRONTSIDE180_MELAN_G_480.m4v'
            },
            'level3' : {
                '8.2_BACKSIDE180_MUTE_KM_G_480.m4v' : 'http://www.trickbagapp.com/Jumping/Goofy/8.2_BACKSIDE180_MUTE_KM_G_480.m4v',
                '8.3_BACKSIDE180_MELAN_G_480.m4v' : 'http://www.trickbagapp.com/Jumping/Goofy/8.3_BACKSIDE180_MELAN_G_480.m4v'
            },
            'level4' : {
                '9.1_FRONTSIDE360_G_480.m4v' : 'http://www.trickbagapp.com/Jumping/Goofy/9.1_FRONTSIDE360_INDY_G_480.m4v',
                '9.2.Frontside360_Mute_G_640.mp4' : 'http://www.trickbagapp.com/videos/jumps/regular/9.2.Frontside360_Mute_640.mp4',
                '9.3.Frontside360_Melon_G_640.mp4' : 'http://www.trickbagapp.com/videos/jumps/regular/9.3.Frontside360_Melon.mp4',
                '9.4_FRONTSIDE360_STALEFISH_MASARU_G_480.m4v' : 'http://www.trickbagapp.com/Jumping/Goofy/9.4_FRONTSIDE360_STALEFISH_MASARU_G_480.m4v'

            },
            'level5' : {
                '10.1_BACKSIDE360_INDY_KM_G_480.m4v' : 'http://www.trickbagapp.com/Jumping/Goofy/10.1_BACKSIDE360_INDY_KM_G_480.m4v',
                '10.5_BACKSIDE360_TAIL_G_480.m4v' : 'http://www.trickbagapp.com/Jumping/Goofy/10.5_BACKSIDE360_TAIL_G_480.m4v'
            },
            'level6' : {
                '11.2_FRONTSIDE540_MUTE_MK_G_480.m4v' : 'http://www.trickbagapp.com/Jumping/Goofy/11.2_FRONTSIDE540_MUTE_MK_G_480.m4v',
                '11.3_FRONTSIDE540_G_480.m4v' : 'http://www.trickbagapp.com/Jumping/Goofy/11.3_FRONTSIDE540_MELAN_G_480.m4v'
            },
            'level7' : {
                '12.1_BACKSIDE540_INDY_G_480.m4v' : 'http://www.trickbagapp.com/Jumping/Goofy/12.1_BACKSIDE540_INDY_G_480.m4v'
            },
            'level8' : {
                '13.3_FRONTSIDE720_MELAN_G_480.m4v' : 'http://www.trickbagapp.com/Jumping/Goofy/13.3_FRONTSIDE720_MELAN_G_480.m4v'
            },
            'level9' : {
                '14.1_BACKSIDE_720_INDY_G_480.m4v' : 'http://www.trickbagapp.com/Jumping/Goofy/14.1_BACKSIDE720_INDY_G_480.m4v',
                '14.2_BACKSIDE720_MUTE_KM_G_480.m4v' : 'http://www.trickbagapp.com/Jumping/Goofy/14.2_BACKSIDE720_MUTE_KM_G_480.m4v'
            },
            'level10' : {
                'BONUS1_METHOD_G_480.m4v' : 'http://www.trickbagapp.com/Jumping/Goofy/BONUS1_METHOD_G_480.m4v',
                'BONUS2_BACKFLIP_G_480.m4v' : 'http://www.trickbagapp.com/Jumping/Goofy/BONUS2_BACKFLIP_G_480.m4v',
                'BONUS3_UNDERFLIP_KM_G_480.m4v' : 'http://www.trickbagapp.com/Jumping/Goofy/BONUS3_UNDERFLIP_KM_G_480.m4v',
                'BONUS4_15.5_FRONTSIDE900_TAIL_G_480.m4v' : 'http://www.trickbagapp.com/Jumping/Goofy/BONUS4_15.5_FRONTSIDE900_TAIL_G_480.m4v',
                'BONUS5_16.2_BACKSIDE900_MUTE_G_480.m4v' : 'http://www.trickbagapp.com/Jumping/Goofy/BONUS5_16.2_BACKSIDE900_MUTE_G_480.m4v',
                'BONUS6_ONEFOOT_INDY_G_480.m4v' : 'http://www.trickbagapp.com/Jumping/Goofy/BONUS6_ONEFOOT_INDY_G_480.m4v',
                'BONUS7_ONEFOOT_BACKSIDE180_G_480.m4v' : 'http://www.trickbagapp.com/Jumping/Goofy/BONUS7_ONEFOOT_BACKSIDE180_G_480.m4v',
                'BONUS8_ONEFOOT_FRONTSIDE360_G_480.m4v' : 'http://www.trickbagapp.com/Jumping/Goofy/BONUS8_ONEFOOT_FRONTSIDE360_G_480.m4v',
                'BONUS9_ONEFOOT_FRONTSIDE540_G_480.m4v' : 'http://www.trickbagapp.com/Jumping/Goofy/BONUS9_ONEFOOT_FRONTSIDE540_G_480.m4v',
                'BONUS10_ONEFOOT_BACKFLIP_G_480.m4v' : 'http://www.trickbagapp.com/Jumping/Goofy/BONUS10_ONEFOOT_BACKFLIP_G_480.m4v'
            }
        }
    }
};

var file_name_to_embed_id = {
    '1_FQ-iPhone.m4v' : 'video1',
    '2_FQ-iPhone.m4v' : 'video2',
    '3_FQ-iPhone.m4v' : 'video3',
    '4_FQ-iPhone.m4v' : 'video4',
    '5_FQ-iPhone.m4v' : 'video5',
    '6_FQ-iPhone.m4v' : 'video6',
    '7_FQ-iPhone.m4v' : 'video7',
    '8_FQ-iPhone.m4v' : 'video8',
    '9_FQ-iPhone.m4v' : 'video9',
    '10_FQ-iPhone.m4v' : 'video10',

    '11_FQ-iPhone.m4v' : 'video11',
    '12_FQ-iPhone.m4v' : 'video12',
    '13_FQ-iPhone.m4v' : 'video13',
    '14_FQ-iPhone.m4v' : 'video14',
    '15_FQ-iPhone.m4v' : 'video15',
    '16_FQ-iPhone.m4v' : 'video16',
    '17_FQ-iPhone.m4v' : 'video17',
    '18_FQ-iPhone.m4v' : 'video18',
    '19_FQ-iPhone.m4v' : 'video19',
    '20_FQ-iPhone.m4v' : 'video20',

    '21_FQ-iPhone.m4v' : 'video21',
    '22_FQ-iPhone.m4v' : 'video22',
    '23_FQ-iPhone.m4v' : 'video23',
    '24_FQ-iPhone.m4v' : 'video24',
    '25_FQ-iPhone.m4v' : 'video25',
    '26_FQ-iPhone.m4v' : 'video26',
    '27_FQ-iPhone.m4v' : 'video27',
    '28_FQ-iPhone.m4v' : 'video28',
    '29_FQ-iPhone.m4v' : 'video29',
    '30_FQ-iPhone.m4v' : 'video30',

    '31_FQ-iPhone.m4v' : 'video31',
    '32_FQ-iPhone.m4v' : 'video32',
    '33_FQ-iPhone.m4v' : 'video33',
    '34_FQ-iPhone.m4v' : 'video34',
    '35_FQ-iPhone.m4v' : 'video35',
    '36_FQ-iPhone.m4v' : 'video36',
    '37_FQ-iPhone.m4v' : 'video37',
    '38_FQ-iPhone.m4v' : 'video38',
    '39_FQ-iPhone.m4v' : 'video39',
    '40_FQ-iPhone.m4v' : 'video40',

    '41_FQ-iPhone.m4v' : 'video41',
    '42_FQ-iPhone.m4v' : 'video42',
    '43_FQ-iPhone.m4v' : 'video43',
    '44_FQ-iPhone.m4v' : 'video44',
    '45_FQ-iPhone.m4v' : 'video45',
    '46_FQ-iPhone.m4v' : 'video46',
    '47_FQ-iPhone.m4v' : 'video47',
    '48_FQ-iPhone.m4v' : 'video48',
    '49_FQ-iPhone.m4v' : 'video49',
    '50_FQ-iPhone.m4v' : 'video50',

    '51_FQ-iPhone.m4v' : 'video51',
    '52_FQ-iPhone.m4v' : 'video52',
    /*'53_FQ-iPhone.m4v' : 'video53',
     '54_FQ-iPhone.m4v' : 'video54',
     '55_FQ-iPhone.m4v' : 'video55',*/
    '56_FQ-iPhone.m4v' : 'video53',
    /*'57_FQ-iPhone.m4v' : 'video57',
     '58_FQ-iPhone.m4v' : 'video58',
     '59_FQ-iPhone.m4v' : 'video59',
     '60_FQ-iPhone.m4v' : 'video60',*/

    '1_iPhone-iPhone.m4v' : 'video61',
    '2_iPhone-iPhone.m4v' : 'video62',
    '3_iPhone-iPhone.m4v' : 'video63',
    '4_iPhone-iPhone.m4v' : 'video64',
    '5_iPhone-iPhone.m4v' : 'video65',
    '6_iPhone-iPhone.m4v' : 'video66',
    '7_iPhone-iPhone.m4v' : 'video67',
    '8_iPhone-iPhone.m4v' : 'video68',
    '9_iPhone-iPhone.m4v' : 'video69',
    '10_iPhone-iPhone.m4v' : 'video70',

    '11_iPhone-iPhone.m4v' : 'video71',
    '12_iPhone-iPhone.m4v' : 'video72',
    '13_iPhone-iPhone.m4v' : 'video73',
    '14_iPhone-iPhone.m4v' : 'video74',
    '15_iPhone-iPhone.m4v' : 'video75',
    '16_iPhone-iPhone.m4v' : 'video76',
    '17_iPhone-iPhone.m4v' : 'video77',
    '18_iPhone-iPhone.m4v' : 'video78',
    '19_iPhone-iPhone.m4v' : 'video79',
    '20_iPhone-iPhone.m4v' : 'video80',

    '21_iPhone-iPhone.m4v' : 'video81',
    '22_iPhone-iPhone.m4v' : 'video82',
    '23_iPhone-iPhone.m4v' : 'video83',
    '24_iPhone-iPhone.m4v' : 'video84',
    '25_iPhone-iPhone.m4v' : 'video85',
    '26_iPhone-iPhone.m4v' : 'video86',
    '27_iPhone-iPhone.m4v' : 'video87',
    '28_iPhone-iPhone.m4v' : 'video88',
    '29_iPhone-iPhone.m4v' : 'video89',
    '30_iPhone-iPhone.m4v' : 'video90',

    '31_iPhone-iPhone.m4v' : 'video91',
    '32_iPhone-iPhone.m4v' : 'video92',
    '33_iPhone-iPhone.m4v' : 'video93',
    '34_iPhone-iPhone.m4v' : 'video94',
    '35_iPhone-iPhone.m4v' : 'video95',
    '36_iPhone-iPhone.m4v' : 'video96',
    '37_iPhone-iPhone.m4v' : 'video97',
    '38_iPhone-iPhone.m4v' : 'video98',
    '39_iPhone-iPhone.m4v' : 'video99',
    '40_iPhone-iPhone.m4v' : 'video100',

    '41_iPhone-iPhone.m4v' : 'video101',
    '42_iPhone-iPhone.m4v' : 'video102',
    '43_iPhone-iPhone.m4v' : 'video103',
    '44_iPhone-iPhone.m4v' : 'video104',
    '45_iPhone-iPhone.m4v' : 'video105',
    '46_iPhone-iPhone.m4v' : 'video106',
    '47_iPhone-iPhone.m4v' : 'video107',
    '48_iPhone-iPhone.m4v' : 'video108',
    '49_iPhone-iPhone.m4v' : 'video109',
    '50_iPhone-iPhone.m4v' : 'video110',

    '51_iPhone-iPhone.m4v' : 'video111',
    '52_iPhone-iPhone.m4v' : 'video112',
    /*'53_iPhone-iPhone.m4v' : 'video113',
     '54_iPhone-iPhone.m4v' : 'video114',
     '55_iPhone-iPhone.m4v' : 'video115',*/
    '56_iPhone-iPhone.m4v' : 'video113',
    /*'57_iPhone-iPhone.m4v' : 'video117',
     '58_iPhone-iPhone.m4v' : 'video118',
     '59_iPhone-iPhone.m4v' : 'video119',
     '60_iPhone-iPhone.m4v' : 'video120',*/


    '1_INDY_GRAB_480.m4v' : 'jump_video1',
    '2_MUTE_GRAB_480.m4v' : 'jump_video2',
    '3_MELAN_GRAB_480.m4v' : 'jump_video3',
    '4_STALEFISH_GRAB_480.m4v' : 'jump_video4',
    '5_TAIL_GRAB_480.m4v' : 'jump_video5',
    '6_NOSE_GRAB_480.m4v' : 'jump_video6',
    '7.3_FRONTSIDE180_480.m4v' : 'jump_video7',
    '8.2_BACKSIDE180_MUTE_KM_480.m4v' : 'jump_video8',
    '8.3_BACKSIDE180_MELAN_480.m4v' : 'jump_video9',
    '9.1_FRONTSIDE360_480.m4v' : 'jump_video10',
    '9.4_FRONTSIDE360_STALEFISH_MASARU_480.m4v' : 'jump_video11',
    '10.1_BACKSIDE360_INDY_KM_480.m4v' : 'jump_video12',
    '10.5_BACKSIDE360_TAIL_480.m4v' : 'jump_video13',
    '11.2_FRONTSIDE540_MUTE_MK_480.m4v' : 'jump_video14',
    '11.3_FRONTSIDE540_480.m4v' : 'jump_video15',
    '12.1_BACKSIDE540_INDY_480.m4v' : 'jump_video16',
    '13.3_FRONTSIDE720_MELAN_480.m4v' : 'jump_video17',
    '14.1_BACKSIDE_720_INDY_480.m4v' : 'jump_video18',
    '14.2_BACKSIDE720_MUTE_KM_480.m4v' : 'jump_video19',
    'BONUS1_METHOD_480.m4v' : 'jump_video20',
    'BONUS2_BACKFLIP_480.m4v' : 'jump_video21',
    'BONUS3_UNDERFLIP_KM_480.m4v' : 'jump_video22',
    'BONUS4_15.5_FRONTSIDE900_TAIL_480.m4v' : 'jump_video23',
    'BONUS5_16.2_BACKSIDE900_MUTE_480.m4v' : 'jump_video24',
    'BONUS6_ONEFOOT_INDY_480.m4v' : 'jump_video25',
    'BONUS7_ONEFOOT_BACKSIDE180_480.m4v' : 'jump_video26',
    'BONUS8_ONEFOOT_FRONTSIDE360_480.m4v' : 'jump_video27',
    'BONUS9_ONEFOOT_FRONTSIDE540_480.m4v' : 'jump_video28',
    'BONUS10_ONEFOOT_BACKFLIP_480.m4v' : 'jump_video29',

    '1_INDY_GRAB_G_480.m4v' : 'jump_video30',
    '2_MUTE_GRAB_G_480.m4v' : 'jump_video31',
    '3_MELAN_GRAB_G_480.m4v' : 'jump_video32',
    '4_STALEFISH_GRAB_G_480.m4v' : 'jump_video33',
    '5_TAIL_GRAB_G_480.m4v' : 'jump_video34',
    '6_NOSE_GRAB_G_480.m4v' : 'jump_video35',
    '7.3_FRONTSIDE180_G_480.m4v' : 'jump_video36',
    '8.2_BACKSIDE180_MUTE_KM_G_480.m4v' : 'jump_video37',
    '8.3_BACKSIDE180_MELAN_G_480.m4v' : 'jump_video38',
    '9.1_FRONTSIDE360_G_480.m4v' : 'jump_video39',
    '9.4_FRONTSIDE360_STALEFISH_MASARU_G_480.m4v' : 'jump_video40',
    '10.1_BACKSIDE360_INDY_KM_G_480.m4v' : 'jump_video41',
    '10.5_BACKSIDE360_TAIL_G_480.m4v' : 'jump_video42',
    '11.2_FRONTSIDE540_MUTE_MK_G_480.m4v' : 'jump_video43',
    '11.3_FRONTSIDE540_G_480.m4v' : 'jump_video44',
    '12.1_BACKSIDE540_INDY_G_480.m4v' : 'jump_video45',
    '13.3_FRONTSIDE720_MELAN_G_480.m4v' : 'jump_video46',
    '14.1_BACKSIDE_720_INDY_G_480.m4v' : 'jump_video47',
    '14.2_BACKSIDE720_MUTE_KM_G_480.m4v' : 'jump_video48',
    'BONUS1_METHOD_G_480.m4v' : 'jump_video49',
    'BONUS2_BACKFLIP_G_480.m4v' : 'jump_video50',
    'BONUS3_UNDERFLIP_KM_G_480.m4v' : 'jump_video51',
    'BONUS4_15.5_FRONTSIDE900_TAIL_G_480.m4v' : 'jump_video52',
    'BONUS5_16.2_BACKSIDE900_MUTE_G_480.m4v' : 'jump_video53',
    'BONUS6_ONEFOOT_INDY_G_480.m4v' : 'jump_video54',
    'BONUS7_ONEFOOT_BACKSIDE180_G_480.m4v' : 'jump_video55',
    'BONUS8_ONEFOOT_FRONTSIDE360_G_480.m4v' : 'jump_video56',
    'BONUS9_ONEFOOT_FRONTSIDE540_G_480.m4v' : 'jump_video57',
    'BONUS10_ONEFOOT_BACKFLIP_G_480.m4v' : 'jump_video58',


    '9.2.Frontside360_Mute_640.mp4' : 'jump_video59',
    '9.3.Frontside360_Melon.mp4' : 'jump_video60',
    '9.2.Frontside360_Mute_G_640.mp4' : 'jump_video61',
    '9.3.Frontside360_Melon_G_640.mp4' : 'jump_video62'

    /*
     <span id="jump_video59" attr-src="http://www.trickbagapp.com/videos/jumps/regular/9.2.Frontside360_Mute_640.mp4"></span>
     <span id="jump_video60" attr-src="http://www.trickbagapp.com/videos/jumps/regular/9.3.Frontside360_Melon.mp4"></span>
     <span id="jump_video61" attr-src="http://www.trickbagapp.com/videos/jumps/goofy/9.2.Frontside360_Mute_G_640.mp4"></span>
     <span id="jump_video62" attr-src="http://www.trickbagapp.com/videos/jumps/goofy/9.3.Frontside360_Melon_G_640.mp4"></span>
     */
};


var RAILS_REG_CHK_PREFIX = 'dl_rails_reg_lvl';
var RAILS_GOOFY_CHK_PREFIX = 'dl_rails_goofy_lvl';
var JUMPS_REG_CHK_PREFIX = 'dl_jumps_reg_lvl';
var JUMPS_GOOFY_CHK_PREFIX = 'dl_jumps_goofy_lvl';
var LEVEL_PREFIX = 'level';
var LEVEL_COUNT = 6;
var JUMP_LEVEL_COUNT = 10;

// Wait for Cordova to load
//

document.addEventListener("deviceready", onDeviceReady, false);

function alertDismissedDownload() {}



function showDownloadAlert(msg) {
    if (typeof navigator != 'undefined' && typeof navigator.notification != 'undefined') {
        navigator.notification.alert(msg, alertDismissedDownload, 'Trick Bag');
    }else {
        alert(msg);
    }
}

function confirmDimissedInitial(button) {
    if (button == 1) {
        if (init_lang == 'en') {
            $('#globalnav .nav_jp').css({display : 'none'});
            $('#globalnav, #globalnav .nav_en').css({display : 'block'});

            jQT.goTo('#how_it_works', 'pop');
        }else {
            $('#globalnav .nav_en').css({display : 'none'});
            $('#globalnav, #globalnav .nav_jp').css({display : 'block'});

            jQT.goTo('#how_it_works_jp', 'pop');
        }
    }else {
        if (init_lang == 'en') jQT.goTo('#optionlist', 'pop');
        else jQT.goTo('#optionlistjp', 'pop');
    }

    //create the flag file
    tl_dir_entry.getFile("first_run", {create: true}, null, null);
}

function showInitialConfirm(lang) {
    init_lang = lang;

    if (typeof navigator != 'undefined' && typeof navigator.notification != 'undefined') {
        if (lang == 'en') {
            navigator.notification.confirm(
                "Would you like to know how the Trick Bag works?",
                confirmDimissedInitial,
                'Trick Bag'
            );
        }else {
            navigator.notification.confirm(
                "トリックバッグの説明は\n必要ですか？",
                confirmDimissedInitial,
                'Trick Bag'
            );
        }

    }else {
        if (lang == 'en') {
            var r=confirm("Would you like to know how the Trick Bag works?");
        }else {
            var r=confirm("トリックバッグの説明は\n必要ですか？");
        }

        if (r==true) {
            //create the flag file
            tl_dir_entry.getFile("first_run", {create: true}, null, null);

            jQT.goTo('#how_it_works', 'pop');
        }else {
            jQT.goTo('#optionlist', 'pop');
        }
    }
}

// Cordova is ready
//
function onDeviceReady() {
    //showDownloadAlert('on device ready');
    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, onFileSystemSuccess, fail);
}

function onFileSystemSuccess(fileSystem) {
    // Get the data directory, creating it if it doesn't exist.
    fileSystem.root.getDirectory("tl_videos", {create: true}, gotDir, fail);
}

function gotDir(directoryEntry) {
    tl_dir_entry = directoryEntry;
    //showDownloadAlert(tl_dir_entry.fullPath);

    //check for the existance of a file which we will use as a flag to determine
    //if the user has already downloaded the videos
    directoryEntry.getFile("first_run", {create: false}, videos_downloaded, download_videos);

    //check for the existance of each level, disable any selections that have already been downloaded
    //update the path of each video that exists locally
    exists_queue = new Array();

    for (var i = 1; i <= LEVEL_COUNT; i++) {
        //tl_video_map.rails.regular['level'+i]
        exists_queue.push({chk_id : RAILS_REG_CHK_PREFIX+i, keys : Object.keys(tl_video_map.rails.regular['level'+i])});
        exists_queue.push({chk_id : RAILS_GOOFY_CHK_PREFIX+i, keys : Object.keys(tl_video_map.rails.goofy['level'+i])});
    }

    for (var i = 1; i <= JUMP_LEVEL_COUNT; i++) {
        exists_queue.push({chk_id : JUMPS_REG_CHK_PREFIX+i, keys : Object.keys(tl_video_map.jumps.regular['level'+i])});
        exists_queue.push({chk_id : JUMPS_GOOFY_CHK_PREFIX+i, keys : Object.keys(tl_video_map.jumps.goofy['level'+i])});
    }

    var file_name = exists_queue[0]['keys'].shift();
    directoryEntry.getFile(file_name, {create: false}, queue_file_exist, queue_file_no_exist);

    //showDownloadAlert('KEYS FUNC TEST: ' + Object.keys(tl_video_map.rails.regular['level1']));
}

function queue_file_exist(entry) {
    //set the path to the local file so it will not stream the video
    var embed_id = file_name_to_embed_id[entry.name];
    var el = document.getElementById(embed_id);
    el.innerHTML = entry.fullPath;

    if (exists_queue[0]['keys'].length > 0) {
        var file_name = exists_queue[0]['keys'].shift();

        //continue checking the rest of this group
        tl_dir_entry.getFile(file_name, {create: false}, queue_file_exist, queue_file_no_exist);

        exists_str += file_name + ' ';
    }else {
        //all files of the current group exist
        //disable this group
        //showDownloadAlert('disabling: ' + exists_queue[0]['chk_id']);
        var box = document.getElementById(exists_queue[0]['chk_id']);
        box.disabled = true;
        box.checked = true;
        box.parentNode.className += ' disabled';

        //move on to the next group if there is one
        exists_queue.shift();
        if (exists_queue.length > 0) {
            var file_name = exists_queue[0]['keys'].shift();
            tl_dir_entry.getFile(file_name, {create: false}, queue_file_exist, queue_file_no_exist);
        }/*else {
         showDownloadAlert('THE FOLLOWING FILES EXIST: ' + exists_str);
         showDownloadAlert('THE FOLLOWING FILES DO NOT EXIST: ' + no_exist_str);
         }*/
    }
}

function queue_file_no_exist(evt) {
    no_exist_str += exists_queue[0]['keys'][0] + ' ';

    //one of the files in this group does not exist
    exists_queue.shift();

    //move on to the next group if there is one
    if (exists_queue.length > 0) {
        var file_name = exists_queue[0]['keys'].shift();
        tl_dir_entry.getFile(file_name, {create: false}, queue_file_exist, queue_file_no_exist);
    }/*else {
     showDownloadAlert('THE FOLLOWING FILES EXIST: ' + exists_str);
     showDownloadAlert('THE FOLLOWING FILES DO NOT EXIST: ' + no_exist_str);
     }*/
}

function download_videos(evt) {
    first_run = true;
    //showInitialConfirm();
}

function download_selection_confirm() {
    var msg = '';

    //if we still have downloads happening, do not continue
    if (download_queue.length > 0) {
        if (download_lang == 'jp') {
            showDownloadAlert('前の選んだビデオはまだダウンロード中です。しばらく、お待ちください。');
        }else {
            showDownloadAlert('Files are still being downloaded from the last selection, please wait until all files have finished downloading');
        }

        return;
    }

    if (download_lang == 'jp') {
        //var r=confirm("ナイス！ダウンロードが終了しましたら、お知らせします。しばらくお待ちください。");
        //if (r==false) {return;}
        msg = "ナイス！ダウンロードが終了しましたら、お知らせします。しばらくお待ちください。";
    }else {
        //var r=confirm("Nice! The videos you have selected will be with you in just a moment. You will be alerted once the download is complete.");
        //if (r==false) {return;}
        msg = "Nice! The videos you have selected will be with you in just a moment. You will be alerted once the download is complete.";
    }

    if (typeof navigator != 'undefined' && typeof navigator.notification != 'undefined') {
        navigator.notification.confirm(
            msg,
            download_selection,
            'Trick Bag'
        );
    }
}

function download_selection(button) {
    if (button != 1) {
        return;
    }

    download_queue = new Array();
    selection_queue = new Array();

    for (var i = 1; i <= LEVEL_COUNT; i++) {
        var regBox = document.getElementById(RAILS_REG_CHK_PREFIX+i);
        var goofyBox = document.getElementById(RAILS_GOOFY_CHK_PREFIX+i);

        if (regBox.checked && !regBox.disabled) {
            selection_queue.push(regBox.id);

            //download the regular selection
            var videos = tl_video_map.rails.regular[LEVEL_PREFIX+i];
            for (var video_key in videos) {
                //add each file to the download queue
                download_queue.push({'file_name' : video_key, 'url' : videos[video_key]});
            }
        }

        if (goofyBox.checked && !goofyBox.disabled) {
            selection_queue.push(goofyBox.id);

            //download the goofy selection
            var videos = tl_video_map.rails.goofy[LEVEL_PREFIX+i];
            for (var video_key in videos) {
                //add each file to the download queue
                download_queue.push({'file_name' : video_key, 'url' : videos[video_key]});
            }
        }
    }

    for (var i = 1; i <= JUMP_LEVEL_COUNT; i++) {
        var regBox = document.getElementById(JUMPS_REG_CHK_PREFIX+i);
        var goofyBox = document.getElementById(JUMPS_GOOFY_CHK_PREFIX+i);

        if (regBox.checked && !regBox.disabled) {
            selection_queue.push(regBox.id);

            //download the regular selection
            var videos = tl_video_map.jumps.regular[LEVEL_PREFIX+i];
            for (var video_key in videos) {
                //add each file to the download queue
                download_queue.push({'file_name' : video_key, 'url' : videos[video_key]});
            }
        }

        if (goofyBox.checked && !goofyBox.disabled) {
            selection_queue.push(goofyBox.id);

            //download the goofy selection
            var videos = tl_video_map.jumps.goofy[LEVEL_PREFIX+i];
            for (var video_key in videos) {
                //showDownloadAlert(video_key);
                //add each file to the download queue
                download_queue.push({'file_name' : video_key, 'url' : videos[video_key]});
            }
        }
    }

    //start the first download.
    if (download_queue.length > 0) {
        num_files_to_download = download_queue.length;
        //showDownloadAlert(download_queue);
        var video = download_queue.shift();
        var fileTransfer = new FileTransfer();
        var uri = encodeURI(video['url']);
        fileTransfer.download(uri, tl_dir_entry.fullPath+'/'+video['file_name'], download_success, download_failure);

        updateDownloadProgress();
    }
}

/*DEPRECATED*/
function videos_downloaded(entry) {
    //make a global reference of the flag entry
    //flag_set = true;
    //flag_entry = entry;

    //update the paths for the videos
    /*for (var i in tl_file_map) {
     tl_dir_entry.getFile(i, {create: false}, download_success, existing_failure);

     var el = document.getElementById('video' + i.substr(0,1));
     el.src = tl_dir_entry.fullPath + '/' + i;
     console.log(el.src);
     }*/
}

/* A video was successfully downloaded */
function download_success(entry) {
    //var file_name = entry.name;
    var embed_id = file_name_to_embed_id[entry.name];

    var el = document.getElementById(embed_id);
    el.innerHTML = entry.fullPath;

    //continue downloading files until the queue is empty
    if (download_queue.length > 0) {
        var video = download_queue.shift();
        var fileTransfer = new FileTransfer();
        var uri = encodeURI(video['url']);
        fileTransfer.download(uri, tl_dir_entry.fullPath+'/'+video['file_name'], download_success, download_failure);

        updateDownloadProgress();
    }else {

        for (var i = 0; i < selection_queue.length; i++) {
            var box = document.getElementById(selection_queue[i]);

            box.disabled = true;
            box.parentNode.className += ' disabled';
        }

        //Empty the queue so an additional download selection can be attempted.
        download_queue = new Array();

        if (download_lang == 'jp') {
            showDownloadAlert('ダウンロード完了！ これらの\nビデオはインターネットを使わなくても見られます。');
        }else {
            showDownloadAlert('Download Success! The videos you selected are now all yours anywhere, anytime - even without Wi-Fi.');
        }

        hideDownloadProgress();
    }
}

/* An error occured while attempting to download a video */
function download_failure(error) {
    if (download_lang == 'jp') {
        showDownloadAlert('ダウンロードのエラーです。インターネットとつないでいるか、チェックしてみてください。');
    }else{
        showDownloadAlert('An error occured while downloading a video, check to make sure you are still connected to the internet.')
    }

    console.log("download error source " + error.source);
    console.log("download error target " + error.target);
    console.log("upload error code" + error.code);

    //An error means something happened, stop where we are and don't continue downloading.
    //Empty the queue so an additional download selection can be attempted
    download_queue = new Array();
    selection_queue = new Array();

    hideDownloadProgress();
}

/* A file that should exist does not exist */
function existing_failure(error) {
    if (flag_set) {
        //delete the flag entry so the next time the app is loaded they will
        //be prompted to download
        flag_set = false;
        flag_entry.remove();
    }
}

/* Generic fail event */
function fail(evt) {
    console.log(evt.target.error.code);
}


function updateDownloadProgress() {
    $('#download-progress').html('Download: ' + (num_files_to_download-download_queue.length) + ' / ' + num_files_to_download);
    $('#download-progress').show();
}

function hideDownloadProgress() {
    $('#download-progress').hide();
}
